#include<stdio.h>

double fact(int n)
// Calcule la factorielle de n
// Hypothèse : n >= 0
{
  double res;
  res = 1.0;
  while (n >= 2) {
    res = res*n;
    n--;
  }
  return res;
}

double fact1(int n) // variante avec boucle for
// Calcule la factorielle de n
// Hypothèse : n >= 0
{
  double res;
  int i;
  res = 1.0;
  for (i=2; i<=n; i++)
    res = res*i;
  return res;
}


double puissance2(double a, int n)
// Calcule a à la puissance n
{
  int i;
  double res = 1.0;
  if (n < 0)
    {
      a = 1/a;
      n = -n;
    }
  for (i=1; i<=n; i++)
    res = res * a;
  return res;
}


double puissance(double a, int n)
// Calcule a à la puissance n
{
  double res = 1.0;
  if (n < 0)
    {
      a = 1/a;
      n = -n;
    }
  while (n >= 1)
    {
      res = res * a;
      n--;
    }
  return res;
}

#define EPSILON (1E-12)


double abs(double x)
{
  if (x >= 0) return  x;
  else        return -x;
}

int egal1(double x, double y)
{
  double diff = abs(x - y);
  if (diff <= EPSILON*abs(x))
      if (diff <= EPSILON*abs(y))
	return 1;
      else
	return 0;
  else
    return 0;
}

int egal2(double x, double y)
{
  double diff = abs(x - y);
  if ((diff <= EPSILON*abs(x)) && (diff <= EPSILON*abs(y)))
    return 1;
  else
    return 0;
}

int egal(double x, double y)
{
  double diff = abs(x - y);
  return ((diff <= EPSILON*abs(x)) && (diff <= EPSILON*abs(y)));
}


double racine_carre(double a)
// Calcule la racine carre de a
// hypothèse : a >= 0
{
  double u;
  u = a;
  while (! egal(u*u, a))
    u = (u + a/u) / 2.0;
  return u;
}


double expo(double x)
{
  int i = 1;
  double u0 = 1.;
  double u1 = u0 + x;
  double v  = x;
  while (! egal(u0, u1))
    {
      i ++;
      v *= x/i;
      u0 = u1;
      u1 += v;
    }
  return u1;
}


double logarithme(double a)
// Calcule le logarithme de a
// hypothèse : a > 0
{
  double u = a;
  double expu = expo(u);
  while (! egal(expu, a))
    {
      u += a / expu - 1.0;
      expu = expo(u);
    }
  return u;
}



void main(void)
{
  double x, r;
  scanf("%lf", &x);
  r = logarithme(x);
  printf("%.20lf, %.20lf\n", r, expo(r));
  printf("%.20lf, %.20lf\n", racine_carre(x), expo(r/2.0));
}

