#include<stdlib.h>
#include<stdio.h>

typedef int elem;

void merge(elem T1[], int min1, int max1,
	   elem T2[], int min2, int max2,
	   elem T[])
/* T est alloué de taille (max1 - min1 + 1) + (max2 - min2 + 1) */
{
  int i1, i2, i;
  i1 = min1; i2 = min2; i = 0;
  while ((i1 <= max1) && (i2 <= max2))
    {
      if (T1[i1] < T2[i2])
	{
	  T[i] = T1[i1]; i++; i1++;
	}
      else
	{
	  T[i] = T2[i2]; i++; i2++;
	}
    }
  if (i1 <= max1)
    do
      {
        T[i] = T1[i1]; i++; i1++;
      }
    while (i1 <= max1);
  else
    do
      {
	T[i] = T2[i2]; i++; i2++;
      }
    while (i2 <= max2);
}


void merge_sort_rec(elem T[], int min, int max, elem Tmp[])
{
  int mid, i, itmp;
  if (min < max)
    {
      mid = (min + max)/2;
      merge_sort_rec(T, min, mid, Tmp);
      merge_sort_rec(T, mid+1, max, Tmp);
      merge(T, min, mid, T, mid+1, max, Tmp);
      for(i=min, itmp=0;
	  i <= max;
	  i++,   itmp++)
	T[i] = Tmp[itmp];
    }
}

void merge_sort(elem T[], int taille)
{
  int *Tmp;
  Tmp = (int *) malloc(taille*sizeof(elem));
  merge_sort_rec(T, 0, taille-1, Tmp);
  free(Tmp);
}

#define SIZE 10000000
elem T[SIZE];

void main(void)
{
  int i;
  for (i=0; i<SIZE; i++)
    T[i] = random();
  // for (i=0; i<SIZE; i++)
  //   printf("%i ", T[i]);
  printf("\n");
  printf("Debut \n");
  merge_sort(T, SIZE);
  printf("Fin \n");
  // for (i=0; i<SIZE; i++)
  //  printf("%i ", T[i]);
  printf("\n");
}
