#include<stdio.h>
#include<stdlib.h>

#define EPSILON 1e-7

double racine_rec(double x, double min, double max)
{
  double mid;
  if ((max-min) < EPSILON) return min;
  else
    {
      mid = (max + min) / 2.;
      if ((mid*mid) < x) return racine_rec(x, mid, max);
      else               return racine_rec(x, min, mid);
    }
}

double racine(double x)
{
  if (x < 0)
    {
      printf("Erreur\n");
      exit(1);
    }
  else if (x < 1) return racine_rec(x, 0, 1);
  else            return racine_rec(x, 1, x);
}

double racine_iter(double x)
{
  double mid, min,  max;

  if (x < 0)
    {
      printf("Erreur\n");
      exit(1);
    }
  else
    if (x < 1) { min = 0; max = 1; }
    else       { min = 1; max = x; };

  while ((max-min) >= EPSILON)
    {
      mid = (max + min) / 2.;
      if ((mid*mid) < x) min = mid;
      else               max = mid;
    }
  return min;
}

void main(void)
{
  float x;
  scanf("%f", &x);
  printf("La racine carree de %f est %f\n", x, racine_iter(x));
}
